<?php
/* $Id: content.inc,v 1.2 2006/07/25 07:01:41 robrechtj Exp $ */

/**
 * Implementation of hook_node_import_types().
 */
function content_node_import_types() {
  $types = array();
  foreach (content_types() as $id => $type) {
    $types[$id] = $type['label'];
  }
  return $types;
}

/**
 * Implementation of hook_node_import_fields().
 */
function content_node_import_fields($type) {
  $types = (array) content_types();
  $fields = array();

  if (isset($types[$type])) {
    $content_type = $types[$type];
    $fields['title'] = $content_type['title_label'];
    foreach ($content_type['fields'] as $field) {
      $fields[$field['field_name']] = $field['widget']['label'];
    }
  }
  return $fields;
}

/**
 * Implementation of hook_node_import_prepare().
 */
function content_node_import_prepare(&$node, $preview = FALSE) {
  $types = (array) content_types();

  if (isset($types[$node->type])) {
    $content_type = $types[$node->type];
    foreach ($content_type['fields'] as $field) {
      if (strpos($field['widget']['type'], 'nodereference') === 0) {
        //nodereference node: query nid of the referenced node
        $referenced_nodes = array();
        $sql = "SELECT nid, title FROM {node} WHERE title SOUNDS LIKE '%s'";
        $result = db_query($sql, $node->$field['field_name']);
        $record_found = db_fetch_object($result);
        if ($record_found) {
          $node_field = array(0 => array('nid' => $record_found->nid));
        } else {
          $node_field = array();
        }
        $node->$field['field_name'] = $node_field;
      } else {
        //default node types: add value to array w/ key 'value'
        $thisval = $node->$field['field_name'];
        if ($field['widget']['type'] == 'weburl') {
          $node->$field['field_name'] = array('value' => $thisval);
        } else {
          $node->$field['field_name'] = array(0 => array('value' => $thisval));
        }
      }
    }
  }
}
